package main

import (
	"net/http"
	"path/filepath"
	"strings"
)

func mimeType(ext string) (bool, string) {
	switch ext {
	case ".jpg", ".jpeg":
		return true, "image/jpeg"

	case ".png":
		return true, "image/png"

	case ".css":
		return true, "text/css"

	default:
		return false, "application/octet-stream"
	}
}

func mimeHeaders(w http.ResponseWriter, path string) {
	extn := strings.ToLower(filepath.Ext(path))

	knownMime, mime := mimeType(extn)
	w.Header().Set("Content-Type", mime)

	if !knownMime {
		w.Header().Set("Content-Disposition", `attachment; filename="`+filepath.Base(path)+`"`) // FIXME sanitize
	}
}
