package main

import (
	"log"
	"net/http"
)

func (this *WebdirApp) RenderError(w http.ResponseWriter, code int, err error) {
	if err != nil {
		log.Printf("%d %s\n", code, err.Error())
	}

	w.WriteHeader(code)

	switch code {
	case 400:
		w.Write([]byte(`400 INVALID REQUEST`))
	case 404:
		w.Write([]byte(`404 NOT FOUND`))
	case 500:
		w.Write([]byte(`500 INTERNAL ERROR`))
	}
}
