package main

import (
	"fmt"
	"io"
	"net/http"
	"os"
)

func (this *WebdirApp) RenderFile(w http.ResponseWriter, path string) {
	absPath, err := this.GetAbsPathFromRel(path)
	if err != nil {
		this.RenderError(w, 400, err)
		return
	}

	// CONTENT-LENGTH

	stat, err := os.Stat(absPath)
	if err != nil {
		this.RenderError(w, 404, err)
		return
	}

	w.Header().Set("Content-Length", fmt.Sprintf("%d", stat.Size()))

	// CONTENT-TYPE

	mimeHeaders(w, absPath)

	// OPEN FILE

	fh, err := os.OpenFile(absPath, os.O_RDONLY, 0400)
	if err != nil {
		this.RenderError(w, 400, err)
		return
	}

	defer fh.Close()

	// WRITE

	w.WriteHeader(200)
	io.Copy(w, fh)
}
