package main

import (
	"fmt"
	"net/http"
)

func (this *WebdirApp) RenderThumb(w http.ResponseWriter, path string) {
	absPath, err := this.GetAbsPathFromRel(path)
	if err != nil {
		this.RenderError(w, 400, err)
		return
	}

	pngThumb, err := this.Thumbnailer.RenderFile(absPath)
	if err != nil {
		this.RenderError(w, 400, err)
		return
	}

	w.Header().Set("Content-Type", "image/png")
	w.Header().Set("Content-Length", fmt.Sprintf("%d", len(pngThumb)))
	w.WriteHeader(200)
	w.Write(pngThumb)
}
